"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const UpdateChanges_1 = require("../common/UpdateChanges");
const version = '19.1.0';
exports.default = () => (host, context) => __awaiter(void 0, void 0, void 0, function* () {
    context.logger.info(`Applying migration for Ignite UI for Angular to version ${version}`);
    const update = new UpdateChanges_1.UpdateChanges(__dirname, host, context);
    update.addValueTransform('fields_to_entities', (args) => {
        args.bindingType = UpdateChanges_1.InputPropertyType.EVAL;
        args.value = `[{ name: '', fields: ${args.value}}]`;
    });
    // remove igx_query_builder_title, igx_query_builder_create_and_group, igx_query_builder_create_or_group from resources
    const removedRS = ['igx_query_builder_title', 'igx_query_builder_create_and_group', 'igx_query_builder_create_or_group'];
    for (const entryPath of update.tsFiles) {
        let content = host.read(entryPath).toString();
        for (const rs of removedRS) {
            const regex = new RegExp(String.raw `,?\s*${rs}\s*:\s*'[^']*'`, 'g');
            if (regex.test(content)) {
                content = content.replace(regex, '');
                host.overwrite(entryPath, content);
            }
        }
    }
    update.applyChanges();
});
